package edu.kit.ipd.descartes.serializer;

import com.google.inject.Inject;
import edu.kit.ipd.descartes.services.StaLangGrammarAccess;
import java.util.List;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.IGrammarAccess;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.nodemodel.INode;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.AbstractElementAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.GroupAlias;
import org.eclipse.xtext.serializer.analysis.GrammarAlias.TokenAlias;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynNavigable;
import org.eclipse.xtext.serializer.analysis.ISyntacticSequencerPDAProvider.ISynTransition;
import org.eclipse.xtext.serializer.sequencer.AbstractSyntacticSequencer;

@SuppressWarnings("all")
public abstract class AbstractStaLangSyntacticSequencer extends AbstractSyntacticSequencer {

	protected StaLangGrammarAccess grammarAccess;
	protected AbstractElementAlias match_Action_ActionKeyword_0_q;
	protected AbstractElementAlias match_BranchAction_BranchActionKeyword_0_q;
	protected AbstractElementAlias match_LoopAction_LoopActionKeyword_0_q;
	protected AbstractElementAlias match_Parameter___TypeKeyword_2_0_EqualsSignKeyword_2_1__q;
	protected AbstractElementAlias match_Parameter___ValueKeyword_4_1_0_EqualsSignKeyword_4_1_1__q;
	protected AbstractElementAlias match_Specification_MetricTypeKeyword_2_q;
	protected AbstractElementAlias match_Specification_RelationalOperatorKeyword_5_q;
	protected AbstractElementAlias match_Specification_SpecificationKeyword_0_q;
	protected AbstractElementAlias match_Specification_ValueKeyword_8_q;
	protected AbstractElementAlias match_StartAction___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_3__q;
	protected AbstractElementAlias match_StopAction___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_3__q;
	protected AbstractElementAlias match_Strategy_WeightingFunctionKeyword_15_q;
	protected AbstractElementAlias match_Tactic_TacticKeyword_0_q;
	protected AbstractElementAlias match_WeightedMetric_WeightedMetricKeyword_0_q;
	protected AbstractElementAlias match_WeightedMetric___MetricTypeKeyword_5_0_EqualsSignKeyword_5_1__q;
	protected AbstractElementAlias match_WeightedMetric___WeightKeyword_8_0_EqualsSignKeyword_8_1__q;
	protected AbstractElementAlias match_WeightedTactic___CurrentKeyword_10_0_EqualsSignKeyword_10_1__q;
	protected AbstractElementAlias match_WeightedTactic___DefaultKeyword_7_0_EqualsSignKeyword_7_1__q;
	protected AbstractElementAlias match_WeightedTactic___LastImpactKeyword_12_1_0_EqualsSignKeyword_12_1_1__q;
	protected AbstractElementAlias match_WeightedTactic___TacticKeyword_4_0_EqualsSignKeyword_4_1__q;
	
	@Inject
	protected void init(IGrammarAccess access) {
		grammarAccess = (StaLangGrammarAccess) access;
		match_Action_ActionKeyword_0_q = new TokenAlias(false, true, grammarAccess.getActionAccess().getActionKeyword_0());
		match_BranchAction_BranchActionKeyword_0_q = new TokenAlias(false, true, grammarAccess.getBranchActionAccess().getBranchActionKeyword_0());
		match_LoopAction_LoopActionKeyword_0_q = new TokenAlias(false, true, grammarAccess.getLoopActionAccess().getLoopActionKeyword_0());
		match_Parameter___TypeKeyword_2_0_EqualsSignKeyword_2_1__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getParameterAccess().getTypeKeyword_2_0()), new TokenAlias(false, false, grammarAccess.getParameterAccess().getEqualsSignKeyword_2_1()));
		match_Parameter___ValueKeyword_4_1_0_EqualsSignKeyword_4_1_1__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getParameterAccess().getValueKeyword_4_1_0()), new TokenAlias(false, false, grammarAccess.getParameterAccess().getEqualsSignKeyword_4_1_1()));
		match_Specification_MetricTypeKeyword_2_q = new TokenAlias(false, true, grammarAccess.getSpecificationAccess().getMetricTypeKeyword_2());
		match_Specification_RelationalOperatorKeyword_5_q = new TokenAlias(false, true, grammarAccess.getSpecificationAccess().getRelationalOperatorKeyword_5());
		match_Specification_SpecificationKeyword_0_q = new TokenAlias(false, true, grammarAccess.getSpecificationAccess().getSpecificationKeyword_0());
		match_Specification_ValueKeyword_8_q = new TokenAlias(false, true, grammarAccess.getSpecificationAccess().getValueKeyword_8());
		match_StartAction___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_3__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getStartActionAccess().getLeftParenthesisKeyword_3_0()), new TokenAlias(false, false, grammarAccess.getStartActionAccess().getRightParenthesisKeyword_3_3()));
		match_StopAction___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_3__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getStopActionAccess().getLeftParenthesisKeyword_3_0()), new TokenAlias(false, false, grammarAccess.getStopActionAccess().getRightParenthesisKeyword_3_3()));
		match_Strategy_WeightingFunctionKeyword_15_q = new TokenAlias(false, true, grammarAccess.getStrategyAccess().getWeightingFunctionKeyword_15());
		match_Tactic_TacticKeyword_0_q = new TokenAlias(false, true, grammarAccess.getTacticAccess().getTacticKeyword_0());
		match_WeightedMetric_WeightedMetricKeyword_0_q = new TokenAlias(false, true, grammarAccess.getWeightedMetricAccess().getWeightedMetricKeyword_0());
		match_WeightedMetric___MetricTypeKeyword_5_0_EqualsSignKeyword_5_1__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getWeightedMetricAccess().getMetricTypeKeyword_5_0()), new TokenAlias(false, false, grammarAccess.getWeightedMetricAccess().getEqualsSignKeyword_5_1()));
		match_WeightedMetric___WeightKeyword_8_0_EqualsSignKeyword_8_1__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getWeightedMetricAccess().getWeightKeyword_8_0()), new TokenAlias(false, false, grammarAccess.getWeightedMetricAccess().getEqualsSignKeyword_8_1()));
		match_WeightedTactic___CurrentKeyword_10_0_EqualsSignKeyword_10_1__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getWeightedTacticAccess().getCurrentKeyword_10_0()), new TokenAlias(false, false, grammarAccess.getWeightedTacticAccess().getEqualsSignKeyword_10_1()));
		match_WeightedTactic___DefaultKeyword_7_0_EqualsSignKeyword_7_1__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getWeightedTacticAccess().getDefaultKeyword_7_0()), new TokenAlias(false, false, grammarAccess.getWeightedTacticAccess().getEqualsSignKeyword_7_1()));
		match_WeightedTactic___LastImpactKeyword_12_1_0_EqualsSignKeyword_12_1_1__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getWeightedTacticAccess().getLastImpactKeyword_12_1_0()), new TokenAlias(false, false, grammarAccess.getWeightedTacticAccess().getEqualsSignKeyword_12_1_1()));
		match_WeightedTactic___TacticKeyword_4_0_EqualsSignKeyword_4_1__q = new GroupAlias(false, true, new TokenAlias(false, false, grammarAccess.getWeightedTacticAccess().getTacticKeyword_4_0()), new TokenAlias(false, false, grammarAccess.getWeightedTacticAccess().getEqualsSignKeyword_4_1()));
	}
	
	@Override
	protected String getUnassignedRuleCallToken(EObject semanticObject, RuleCall ruleCall, INode node) {
		return "";
	}
	
	
	@Override
	protected void emitUnassignedTokens(EObject semanticObject, ISynTransition transition, INode fromNode, INode toNode) {
		if (transition.getAmbiguousSyntaxes().isEmpty()) return;
		List<INode> transitionNodes = collectNodes(fromNode, toNode);
		for (AbstractElementAlias syntax : transition.getAmbiguousSyntaxes()) {
			List<INode> syntaxNodes = getNodesFor(transitionNodes, syntax);
			if(match_Action_ActionKeyword_0_q.equals(syntax))
				emit_Action_ActionKeyword_0_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_BranchAction_BranchActionKeyword_0_q.equals(syntax))
				emit_BranchAction_BranchActionKeyword_0_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_LoopAction_LoopActionKeyword_0_q.equals(syntax))
				emit_LoopAction_LoopActionKeyword_0_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_Parameter___TypeKeyword_2_0_EqualsSignKeyword_2_1__q.equals(syntax))
				emit_Parameter___TypeKeyword_2_0_EqualsSignKeyword_2_1__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_Parameter___ValueKeyword_4_1_0_EqualsSignKeyword_4_1_1__q.equals(syntax))
				emit_Parameter___ValueKeyword_4_1_0_EqualsSignKeyword_4_1_1__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_Specification_MetricTypeKeyword_2_q.equals(syntax))
				emit_Specification_MetricTypeKeyword_2_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_Specification_RelationalOperatorKeyword_5_q.equals(syntax))
				emit_Specification_RelationalOperatorKeyword_5_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_Specification_SpecificationKeyword_0_q.equals(syntax))
				emit_Specification_SpecificationKeyword_0_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_Specification_ValueKeyword_8_q.equals(syntax))
				emit_Specification_ValueKeyword_8_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_StartAction___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_3__q.equals(syntax))
				emit_StartAction___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_3__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_StopAction___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_3__q.equals(syntax))
				emit_StopAction___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_3__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_Strategy_WeightingFunctionKeyword_15_q.equals(syntax))
				emit_Strategy_WeightingFunctionKeyword_15_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_Tactic_TacticKeyword_0_q.equals(syntax))
				emit_Tactic_TacticKeyword_0_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_WeightedMetric_WeightedMetricKeyword_0_q.equals(syntax))
				emit_WeightedMetric_WeightedMetricKeyword_0_q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_WeightedMetric___MetricTypeKeyword_5_0_EqualsSignKeyword_5_1__q.equals(syntax))
				emit_WeightedMetric___MetricTypeKeyword_5_0_EqualsSignKeyword_5_1__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_WeightedMetric___WeightKeyword_8_0_EqualsSignKeyword_8_1__q.equals(syntax))
				emit_WeightedMetric___WeightKeyword_8_0_EqualsSignKeyword_8_1__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_WeightedTactic___CurrentKeyword_10_0_EqualsSignKeyword_10_1__q.equals(syntax))
				emit_WeightedTactic___CurrentKeyword_10_0_EqualsSignKeyword_10_1__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_WeightedTactic___DefaultKeyword_7_0_EqualsSignKeyword_7_1__q.equals(syntax))
				emit_WeightedTactic___DefaultKeyword_7_0_EqualsSignKeyword_7_1__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_WeightedTactic___LastImpactKeyword_12_1_0_EqualsSignKeyword_12_1_1__q.equals(syntax))
				emit_WeightedTactic___LastImpactKeyword_12_1_0_EqualsSignKeyword_12_1_1__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else if(match_WeightedTactic___TacticKeyword_4_0_EqualsSignKeyword_4_1__q.equals(syntax))
				emit_WeightedTactic___TacticKeyword_4_0_EqualsSignKeyword_4_1__q(semanticObject, getLastNavigableState(), syntaxNodes);
			else acceptNodes(getLastNavigableState(), syntaxNodes);
		}
	}

	/**
	 * Syntax:
	 *     'Action'?
	 */
	protected void emit_Action_ActionKeyword_0_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     'BranchAction'?
	 */
	protected void emit_BranchAction_BranchActionKeyword_0_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     'LoopAction'?
	 */
	protected void emit_LoopAction_LoopActionKeyword_0_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     ('type' '=')?
	 */
	protected void emit_Parameter___TypeKeyword_2_0_EqualsSignKeyword_2_1__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     ('value' '=')?
	 */
	protected void emit_Parameter___ValueKeyword_4_1_0_EqualsSignKeyword_4_1_1__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     'metricType'?
	 */
	protected void emit_Specification_MetricTypeKeyword_2_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     'relationalOperator'?
	 */
	protected void emit_Specification_RelationalOperatorKeyword_5_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     'Specification'?
	 */
	protected void emit_Specification_SpecificationKeyword_0_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     'value'?
	 */
	protected void emit_Specification_ValueKeyword_8_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     ('(' ')')?
	 */
	protected void emit_StartAction___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_3__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     ('(' ')')?
	 */
	protected void emit_StopAction___LeftParenthesisKeyword_3_0_RightParenthesisKeyword_3_3__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     'weightingFunction'?
	 */
	protected void emit_Strategy_WeightingFunctionKeyword_15_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     'Tactic'?
	 */
	protected void emit_Tactic_TacticKeyword_0_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     'WeightedMetric'?
	 */
	protected void emit_WeightedMetric_WeightedMetricKeyword_0_q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     ('metricType' '=')?
	 */
	protected void emit_WeightedMetric___MetricTypeKeyword_5_0_EqualsSignKeyword_5_1__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     ('weight' '=')?
	 */
	protected void emit_WeightedMetric___WeightKeyword_8_0_EqualsSignKeyword_8_1__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     ('current' '=')?
	 */
	protected void emit_WeightedTactic___CurrentKeyword_10_0_EqualsSignKeyword_10_1__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     ('default' '=')?
	 */
	protected void emit_WeightedTactic___DefaultKeyword_7_0_EqualsSignKeyword_7_1__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     ('lastImpact' '=')?
	 */
	protected void emit_WeightedTactic___LastImpactKeyword_12_1_0_EqualsSignKeyword_12_1_1__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
	/**
	 * Syntax:
	 *     ('tactic' '=')?
	 */
	protected void emit_WeightedTactic___TacticKeyword_4_0_EqualsSignKeyword_4_1__q(EObject semanticObject, ISynNavigable transition, List<INode> nodes) {
		acceptNodes(transition, nodes);
	}
	
}
